package walk

import (
	"reflect"
)

func Walk(x interface{}, fn func(string)) {
	val := reflect.ValueOf(x)
	for i := 0; i < val.NumField(); i++ {
		field := val.Field(i)

		switch field.Kind() {
		case reflect.String:
			fn(field.String())
		case reflect.Struct:
			// XXX: Interface() to get interface
			Walk(field.Interface(), fn)
		}
	}
}
